



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>《第一行代码》学习笔记38－服务Service（5）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">《第一行代码》学习笔记38－服务Service（5）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 14:40:17 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>1.希望服务一旦启动就立刻去执行某个动作，可以将逻辑写在onStartCommand()方法里。</p>
<p>2.onCreate()和onStartCommand()的区别：onCreate()方法是在服务第一次创建时调用的，而onStartCommand()方<br /><br />
法在每次启动服务时都会调用。</p>
<p>3.调用bindService()方法将MainActivity和MyService进行绑定，bindService()方法接收三个参数，第一个是刚刚创建的<br /><br />
Intent对象；第二个是前面创建出的ServiceConnection实例；第三个是一个标志位，这里传入BIND_AUTO_CREATE表示<br /><br />
在活动和服务进行绑定后自动创建服务。会使得MyService中的onCreate()方法得到执行，但onStartCommand()方法不会<br /><br />
执行。</p>
<p>4.服务的生命周期：onCreate(), onStartCommand, onBind() 和 onDestroy()等方法都是在服务的生命周期内可能回调的方法。</p>
<p>5.虽然每调用一次startService()方法，onStartCommand()就会执行一次，但实际上每个服务都只会存在一个实例。故不管调用<br /><br />
了多少次startService()方法，只需要调用一次stopService()或stopSelf()方法，服务就会停下来。</p>
<p>6.根据Android系统的机制，一个服务只要被启动或者被绑定之后，就会一直处于运行状态，必须要让以上两种条件同时不满足，<br /><br />
服务才能被销毁。所以，这种情况下要同时调用stopService()和unbindService()方法，onDestroy()方法才会执行。</p>
<p>7.服务的系统优先级比较低，系统出现内存不足的情况时，有可能会回收掉正在后台运行的服务。</p>
<p>8.考虑前台服务，该服务和普通服务最大的区别在于，会一直有一个正在运行的图标在系统的状态栏显示，下拉状态栏后可以<br /><br />
看到更加详细的信息，非常类似于通知的效果。eg.有些项目由于特殊的需求会要求必须使用前台服务，如墨迹天气，其服务<br /><br />
在后台更新天气数据的同时，还会在系统状态栏一直显示当前的天气信息。</p>
<p>9.关于前台服务的核心代码：</p>
<pre class="prettyprint linenums"><code>Notification.Builder builder = new Notification.Builder(MyService.this);<br />
        Intent intent = new Intent(this, MainActivity.class);<br />
        PendingIntent pi = PendingIntent.getActivity(this, 0, intent, PendingIntent.FLAG_CANCEL_CURRENT);

        builder.setSmallIcon(R.mipmap.ic_launcher);<br />
        builder.setTicker(&quot;Notification comes&quot;);<br />
        builder.setWhen(System.currentTimeMillis());<br />
        builder.setAutoCancel(true);<br />
        builder.setContentTitle(&quot;This is content title&quot;);<br />
        builder.setContentText(&quot;This is content text&quot;);<br />
        Notification n = builder.build();<br />
        builder.setContentIntent(pi);

        startForeground(1, n);<br />
</code></pre>
<p>10.服务中的代码都是默认运行在主线程中的，若直接在服务中去处理一些耗时的逻辑，会很容易出现ANR（Application Not Responding）<br /><br />
的情况，故用到Android多线程编程技术，在服务的每个具体的方法里开启一个子线程，然后在这里去处理那些耗时的逻辑。</p>
<p>11.IntentService集开启线程和自动停止于一身，得到了众多程序员的喜爱。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pxx2dq.html">关于UIView的AutoresizingMask属性的研究</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rkw7eq.html">C&num;编程总结（四）多线程应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ow57p9.html">bootstrap-collapse</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okg34l9.html">WinForm 资源文件的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yv153q.html">中国剩余定理模板poj1006</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv15y0oq.html">在Vista以上版本运行WTL程序，有时候会提示&OpenCurlyDoubleQuote;这个程序可能安装补正确&period;&period;&period;&rdquo;的错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meek02q.html">用bat 删除当前文件夹下的某类文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdvrj79.html">mac 安装mysql特种报错的对应解决方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkx7ke8.html">python3操作pymsql模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp3zw0q.html">SpringBoot实战 之 异常处理篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1zz049.html">C&plus;&plus;中字符串换行（如何拆分为多行）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jj4meq.html">Hashtable与Dictionary比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjmv079.html">转《service worker在移动端H5项目的应用》</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjm71r9.html">【CF446C】DZY Loves Fibonacci Numbers （线段树 &plus; 斐波那契数列）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2x73pq.html">【PAT】B1071 小赌怡情（15 分）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5xkm4q.html">Samsung&lowbar;tiny4412&lpar;驱动笔记04&rpar;----volatile&comma;container&lowbar;of&comma;file&lowbar;operations&comma;file&comma;inode</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpmzge9.html">assign&lpar;&rpar;函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pdvez8.html">MySQL数据库----函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnngky3q.html">Mybatis工作原理（含部分源码）</a>
		</li>
						<li><a href="https://www.batexi.com/a/902orrmq.html">Ubuntu14&period;04 安装中文输入法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2wzoyxq.html">android 手机信息获取</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z3zm49.html">Linux命令记录</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd2dk38.html">VHDL学习之TEXTIO在仿真中的应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xzyo09.html">android-UI组件实例大全&lpar;六&rpar;------ImageView图像视图</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn0e52q.html">Altium Designer 画&amp;quot&semi;差分线&amp;quot&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdxgod8.html">17 个 Linux 下用于 C&sol;C&plus;&plus; 的最好的 IDE</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vgmwo8.html">Delphi IDHTTP用法详解（六种用法）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjrwe49.html">Mysql 存储过程和函数区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn02g2q.html">ss命令&comma;显示socket状态</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydkvx2q.html">bzoj3997&lbrack;TJOI2015&rsqb;组合数学</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
